//+------------------------------------------------------------------+
//|                                             2 Price Channels.mq4 |
//|                                 Copyright  2008, Bigeev Rustem. |
//|                                             http://www.parch.ru/ |
//+------------------------------------------------------------------+

extern double Lots = 0.1;
extern bool   TrailingStop = true;
extern double LongPC       = 50;
extern int    TP           = 15;
extern int    MaxStop      = 150;
int start()
  {
   double res,res_m,res_c;
   double LHigh,LLow,LHigh2,LLow2,SL,LMedium,LMedium2,SMedium,SMedium2;   
   int total, ticket, cnt;

   if(Volume[0]>1) return;  //     .

//        .

   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }

//       
   LHigh=iCustom(NULL,0,"PriceChannel",LongPC,0,1);      
   LLow=iCustom(NULL,0,"PriceChannel",LongPC,1,1);       
   LHigh2=iCustom(NULL,0,"PriceChannel",LongPC,0,2);      
   LLow2=iCustom(NULL,0,"PriceChannel",LongPC,1,2);       
  
   LMedium=iCustom(NULL,0,"PriceChannel",LongPC,2,1);
   LMedium2=iCustom(NULL,0,"PriceChannel",LongPC,2,2);

  
   
//        
   total=OrdersTotal();
   if(total<1) //   ,     
     {
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }

//            
      if(LMedium > LMedium2)  //(SMedium >= LMedium) ||  
        {
          ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,LLow2,0,"2-PriceChannel",12345,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice(),"  LMedium=",LMedium);
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
        
//              
      if(LMedium < LMedium2)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,LHigh2,0,"2-PriceChannel",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice(),"LMedium= ",LMedium);
           }
         else Print("Error opening SELL order : ",GetLastError()); 
            return(0); 
        }
      return(0);
     }
   
   
   
//      .
//if (Volume[0]>1)

for(cnt=0;cnt<total;cnt++)
      {
      res=OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (res==false) Print("    ",GetLastError());
      
//        
      if(OrderType()==OP_BUY)   //    && Volume[0]>1
           {          
            if(TrailingStop)  
              {            
               if (High[0] >= LHigh2) SL=LMedium; else SL=LLow;  
               res_m=OrderModify(OrderTicket(),OrderOpenPrice(),SL,0,Green);
               if (res_m==false) Print("    ",GetLastError());
               return(0);
              }
           }   
//                 
      if(OrderType()==OP_SELL )  //     && Volume[0]>1
           {
            if(TrailingStop)  
              {
               if (Low[0] <= LLow2) SL=LMedium; else SL=LHigh;  
               res_m=OrderModify(OrderTicket(),OrderOpenPrice(),LHigh,0,Red);
               if (res_m==false) Print("    ",GetLastError());
               return(0);
              }
           }
      }    
return(0); 
}
// the end.